<?php
/*-----------------------------------------------------------------------------
 * main.php
 * All main functionality.
 *-----------------------------------------------------------------------------
 */

// say something if there is something to be said

if (isset($in_nick) && $in_nick != "" && isset($in_text) && $in_text != "") {

	$chan_in_file = "$BASE_DIR/$IRC_SERVER/$IRC_CHANNEL/in";

	$in_nick = str_replace(" ", "", stripslashes($in_nick));
	$in_text = stripslashes($in_text);

	// remove line breaks from user input
	$in_nick = str_replace("\r", "", str_replace("\n", "", $in_nick));
	$in_text = str_replace("\r", "", str_replace("\n", "", $in_text));

	if (is_writable("$chan_in_file")) {
		$handle = fopen("$chan_in_file", 'a');
		if ($handle === false) {
			echo "$chan_in_file could not be opened.";
			return;
		} else {
			if (!fwrite($handle, "<${in_nick}> ${in_text}\n")) {
				echo "Could not write to ${chan_in_file}.";
				fclose($handle);
				return;
			}
			fclose($handle);	
		}
	} else {
		echo "$chan_in_file is not writable. Check your file permissions.";
		return;
	}
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
	<?php
	echo "<title>phpii - $IRC_CHANNEL on $IRC_SERVER</title>";
	/*
	if (isset($in_nick) && $in_nick != "")
		echo "	<meta http-equiv=\"refresh\" content=\"5; URL=index.php?in_nick=$in_nick\">";
	else
		echo "	<meta http-equiv=\"refresh\" content=\"5; URL=index.php\">";
	*/
	?>
<link rel="stylesheet" type="text/css" href="phpii.css">
</head>

<body>
<?php

$out = file ("$BASE_DIR/$IRC_SERVER/$IRC_CHANNEL/out");
$out_num_lines = count($out);
if ($out_num_lines == 0) {
	echo "Nothing to be displayed.";
	echo "</body>";
	echo "</html>";
	return;
}
?>

<table>
<?php
echo "<tr><th colspan=\"3\">$IRC_CHANNEL on $IRC_SERVER</th></tr>";
for ($i = count($out) - $NUM_LAST_LINES; $i < count($out); $i++) {
	$line = $out[$i];
	#$line = str_replace("/n ", "", $line);	# workaround for bug in ii, fixed since 2006-01-29
	list($time, $nick, $text) = explode(" ", $line, 3);
	if ($nick == "-!-") {
		// "-!-" marks a status message
		if (strstr($text, "has joined") != FALSE) {
			$rowtype = "join";
			$nick = "-->";
		} else if (strstr($text, "has left") != FALSE) {
			$rowtype = "part";
			$nick = "<--";
		} else if (strstr($text, "changed nick to") != FALSE) {
			$rowtype = "nickchange";
			$nick = "<->";
		} else if (strstr($text, "has quit") != FALSE) {
			$rowtype = "quit";
			$nick = "<==";
		} else if (strstr($text, "changed topic to") != FALSE) {
			$rowtype = "topic";
		} else {
			$rowtype = "UNKNOWN";
		}
		$text = htmlentities($text);
	} else {
		if (substr($text, 1, 6) == "ACTION") {
			$text = "<b>" . htmlentities(substr($nick, 1, strlen($nick) - 2))
				. "</b>" . htmlentities(substr($text, 7, strlen($text) - 9));
			$nick = "-!-";
			$rowtype = "action";
		} else {
			// normal text message - use alternating colors
			if ($i % 2 == 0) $rowtype = "dark"; else $rowtype = "bright";
			$text = htmlentities($text);
		}
	}
	echo "<tr id=\"$rowtype\"><td id=\"time\">";
	echo (htmlentities($time));
	echo "</td><td id=\"nick\">";
	echo (htmlentities($nick));
	echo "</td><td id=\"text\">";
	echo $text;
	echo "</td></tr>\n";
}

?> 
</table>

<div id="input">
	<?php
	/* show a small status bar if neccessary */
	if (isset($in_text) && $in_text != "") {
		echo "	<div id=\"status\">";

		if (!isset($in_nick) || $in_nick == "")
			echo "		<b>You have to enter a nickname to say something.</b>";
		else
			echo "		<b>You have just said:</b> " . htmlentities($in_text);
		echo "	</div>";
	}
	?>
	<form action="index.php" method="post">
		<?php
		if (isset($in_nick) && $in_nick != "") $nv = "value=\"$in_nick\" "; else $nv = "";
		echo "		nick: <input id=\"nick\" name=\"in_nick\" type=\"text\" size=\"12\" maxlength=\"16\" $nv>";
	?>
		text: <input name="in_text" type="text" size="80" maxlength="200">
		<input id="button" type="submit" value="send / refresh">
	</form>
</div>

<div id="about">
	<a class="about" href="http://yogan.meinungsverstaerker.de/phpii/">phpii</a>,
	a php based web frontend for the irc client <a class="about" href="http://wmii.de/wmii/index.php?page=ii">ii</a>.
</div>

</body>
</html>
